<?php

namespace Intergo\MessageClient;

use Intergo\BaseClient\Client;
use Intergo\BaseClient\Responses\BaseResponseInterface;

class AbstractMessageService
{

    /** @var MessageClient */
    protected $client;

    /**
     * AbstractMessageService constructor.
     *
     * @param $baseUrl
     * @param $traceId
     */
    public function __construct($baseUrl, $traceId)
    {
        $this->client = new MessageClient($baseUrl, $traceId);
    }

    /**
     * @param string $user_id
     * @param array $settings
     * @return BaseResponseInterface
     */
    public function updateUserSettingsV2(string $user_id, array $settings)
    {
        return $this->execute(__FUNCTION__, compact('user_id'), $settings);
    }

    /**
     * @param string $user_id
     * @param array $viber_settings
     * @param array $viber_prices
     * @return BaseResponseInterface
     */
    public function updateViberSettings(string $user_id, array $viber_settings, array $viber_prices)
    {
        return $this->execute(__FUNCTION__, compact('user_id'), compact('viber_settings', 'viber_prices'));
    }

    /**
     * @param string $user_id
     * @param array $settings
     * @return BaseResponseInterface
     */
    public function getUserSettings(string $user_id)
    {
        return $this->execute(__FUNCTION__, compact('user_id'), []);
    }

    /**
     * @param string $user_id
     * @param array $settings
     * @return BaseResponseInterface
     */
    public function invalidateUserLists(string $user_id)
    {
        return $this->execute(__FUNCTION__, compact('user_id'), []);
    }

}